package jp.deadend.noname.lastapp;

import android.app.Activity;
import android.app.ActivityManager;
import android.app.ActivityManager.RunningTaskInfo;
import android.content.ComponentName;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.view.Window;
import android.util.Log;

import java.util.ArrayList;
import java.util.List;

public class LastApp extends Activity {
	private class AppName {
		String packageName;
		String className;

		public AppName(String pn, String cn) {
			packageName = pn;
			className = cn;
		}
	}

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		requestWindowFeature(Window.FEATURE_NO_TITLE);

		ActivityManager activityManager = (ActivityManager)getSystemService(ACTIVITY_SERVICE);
		List<ActivityManager.RecentTaskInfo> recentTasks = activityManager.getRecentTasks(10, 0);
		if (recentTasks.size() < 2) finish();

		List<AppName> excludedApps = new ArrayList<AppName>();
		SharedPreferences sp = PreferenceManager.getDefaultSharedPreferences(getApplicationContext());
		String prefStr = sp.getString(ExcludeListActivity.KEY_EXCLUDED_APP, "");
		if (!prefStr.equals("")) {
			String[] apps = prefStr.split(":");
			for (String str : apps) {
				String[] names = str.split(",");
				excludedApps.add(new AppName(names[0], names[1]));
			}
		}

		int i = 1;
		Intent intent = null;
		while (intent == null && i < recentTasks.size()) {
			ActivityManager.RecentTaskInfo info = recentTasks.get(i);
			intent = new Intent(info.baseIntent);
			if (info.origActivity != null) {
				intent.setComponent(info.origActivity);
			}

			if (info.id == -1) {
				intent = null;
				i++;
				continue;
			}

			for (AppName app : excludedApps) {
				ComponentName c = intent.getComponent();
				if (c.getPackageName().equals(app.packageName) && c.getClassName().equals(app.className)) {
					intent = null;
					break;
				}
			}
			i++;
		}

		if (intent != null) {
			intent.setFlags((intent.getFlags()&~Intent.FLAG_ACTIVITY_RESET_TASK_IF_NEEDED) | Intent.FLAG_ACTIVITY_NEW_TASK);
			startActivity(intent);
		}
		finish();
	}
}
